


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/dcerpc/v5/bkrp.py: 82%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/dcerpc/v5/bkrp.py</b> :
            <span class="pc_cov">82%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            46 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">39 run</span>
            <span class="mis shortkey_m button_toggle_mis">7 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">0 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="pln"><a href="#n17">17</a></p>
<p id="n18" class="pln"><a href="#n18">18</a></p>
<p id="n19" class="pln"><a href="#n19">19</a></p>
<p id="n20" class="pln"><a href="#n20">20</a></p>
<p id="n21" class="pln"><a href="#n21">21</a></p>
<p id="n22" class="pln"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="stm run hide_run"><a href="#n24">24</a></p>
<p id="n25" class="stm run hide_run"><a href="#n25">25</a></p>
<p id="n26" class="stm run hide_run"><a href="#n26">26</a></p>
<p id="n27" class="stm run hide_run"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="stm run hide_run"><a href="#n29">29</a></p>
<p id="n30" class="stm run hide_run"><a href="#n30">30</a></p>
<p id="n31" class="pln"><a href="#n31">31</a></p>
<p id="n32" class="stm run hide_run"><a href="#n32">32</a></p>
<p id="n33" class="pln"><a href="#n33">33</a></p>
<p id="n34" class="stm run hide_run"><a href="#n34">34</a></p>
<p id="n35" class="stm run hide_run"><a href="#n35">35</a></p>
<p id="n36" class="stm mis"><a href="#n36">36</a></p>
<p id="n37" class="pln"><a href="#n37">37</a></p>
<p id="n38" class="stm run hide_run"><a href="#n38">38</a></p>
<p id="n39" class="stm mis"><a href="#n39">39</a></p>
<p id="n40" class="stm mis"><a href="#n40">40</a></p>
<p id="n41" class="stm mis"><a href="#n41">41</a></p>
<p id="n42" class="stm mis"><a href="#n42">42</a></p>
<p id="n43" class="stm mis"><a href="#n43">43</a></p>
<p id="n44" class="pln"><a href="#n44">44</a></p>
<p id="n45" class="stm mis"><a href="#n45">45</a></p>
<p id="n46" class="pln"><a href="#n46">46</a></p>
<p id="n47" class="pln"><a href="#n47">47</a></p>
<p id="n48" class="pln"><a href="#n48">48</a></p>
<p id="n49" class="pln"><a href="#n49">49</a></p>
<p id="n50" class="pln"><a href="#n50">50</a></p>
<p id="n51" class="stm run hide_run"><a href="#n51">51</a></p>
<p id="n52" class="stm run hide_run"><a href="#n52">52</a></p>
<p id="n53" class="stm run hide_run"><a href="#n53">53</a></p>
<p id="n54" class="stm run hide_run"><a href="#n54">54</a></p>
<p id="n55" class="pln"><a href="#n55">55</a></p>
<p id="n56" class="pln"><a href="#n56">56</a></p>
<p id="n57" class="pln"><a href="#n57">57</a></p>
<p id="n58" class="pln"><a href="#n58">58</a></p>
<p id="n59" class="stm run hide_run"><a href="#n59">59</a></p>
<p id="n60" class="stm run hide_run"><a href="#n60">60</a></p>
<p id="n61" class="pln"><a href="#n61">61</a></p>
<p id="n62" class="stm run hide_run"><a href="#n62">62</a></p>
<p id="n63" class="stm run hide_run"><a href="#n63">63</a></p>
<p id="n64" class="pln"><a href="#n64">64</a></p>
<p id="n65" class="pln"><a href="#n65">65</a></p>
<p id="n66" class="pln"><a href="#n66">66</a></p>
<p id="n67" class="pln"><a href="#n67">67</a></p>
<p id="n68" class="stm run hide_run"><a href="#n68">68</a></p>
<p id="n69" class="stm run hide_run"><a href="#n69">69</a></p>
<p id="n70" class="pln"><a href="#n70">70</a></p>
<p id="n71" class="pln"><a href="#n71">71</a></p>
<p id="n72" class="pln"><a href="#n72">72</a></p>
<p id="n73" class="pln"><a href="#n73">73</a></p>
<p id="n74" class="pln"><a href="#n74">74</a></p>
<p id="n75" class="pln"><a href="#n75">75</a></p>
<p id="n76" class="pln"><a href="#n76">76</a></p>
<p id="n77" class="stm run hide_run"><a href="#n77">77</a></p>
<p id="n78" class="stm run hide_run"><a href="#n78">78</a></p>
<p id="n79" class="pln"><a href="#n79">79</a></p>
<p id="n80" class="pln"><a href="#n80">80</a></p>
<p id="n81" class="pln"><a href="#n81">81</a></p>
<p id="n82" class="pln"><a href="#n82">82</a></p>
<p id="n83" class="pln"><a href="#n83">83</a></p>
<p id="n84" class="pln"><a href="#n84">84</a></p>
<p id="n85" class="pln"><a href="#n85">85</a></p>
<p id="n86" class="pln"><a href="#n86">86</a></p>
<p id="n87" class="pln"><a href="#n87">87</a></p>
<p id="n88" class="pln"><a href="#n88">88</a></p>
<p id="n89" class="pln"><a href="#n89">89</a></p>
<p id="n90" class="pln"><a href="#n90">90</a></p>
<p id="n91" class="pln"><a href="#n91">91</a></p>
<p id="n92" class="stm run hide_run"><a href="#n92">92</a></p>
<p id="n93" class="stm run hide_run"><a href="#n93">93</a></p>
<p id="n94" class="stm run hide_run"><a href="#n94">94</a></p>
<p id="n95" class="pln"><a href="#n95">95</a></p>
<p id="n96" class="pln"><a href="#n96">96</a></p>
<p id="n97" class="pln"><a href="#n97">97</a></p>
<p id="n98" class="pln"><a href="#n98">98</a></p>
<p id="n99" class="pln"><a href="#n99">99</a></p>
<p id="n100" class="pln"><a href="#n100">100</a></p>
<p id="n101" class="stm run hide_run"><a href="#n101">101</a></p>
<p id="n102" class="stm run hide_run"><a href="#n102">102</a></p>
<p id="n103" class="pln"><a href="#n103">103</a></p>
<p id="n104" class="pln"><a href="#n104">104</a></p>
<p id="n105" class="pln"><a href="#n105">105</a></p>
<p id="n106" class="pln"><a href="#n106">106</a></p>
<p id="n107" class="pln"><a href="#n107">107</a></p>
<p id="n108" class="pln"><a href="#n108">108</a></p>
<p id="n109" class="pln"><a href="#n109">109</a></p>
<p id="n110" class="pln"><a href="#n110">110</a></p>
<p id="n111" class="stm run hide_run"><a href="#n111">111</a></p>
<p id="n112" class="pln"><a href="#n112">112</a></p>
<p id="n113" class="pln"><a href="#n113">113</a></p>
<p id="n114" class="pln"><a href="#n114">114</a></p>
<p id="n115" class="pln"><a href="#n115">115</a></p>
<p id="n116" class="pln"><a href="#n116">116</a></p>
<p id="n117" class="pln"><a href="#n117">117</a></p>
<p id="n118" class="stm run hide_run"><a href="#n118">118</a></p>
<p id="n119" class="stm run hide_run"><a href="#n119">119</a></p>
<p id="n120" class="stm run hide_run"><a href="#n120">120</a></p>
<p id="n121" class="stm run hide_run"><a href="#n121">121</a></p>
<p id="n122" class="stm run hide_run"><a href="#n122">122</a></p>
<p id="n123" class="stm run hide_run"><a href="#n123">123</a></p>
<p id="n124" class="pln"><a href="#n124">124</a></p>
<p id="n125" class="stm run hide_run"><a href="#n125">125</a></p>
<p id="n126" class="stm run hide_run"><a href="#n126">126</a></p>
<p id="n127" class="stm run hide_run"><a href="#n127">127</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># Author: Alberto Solino (@agsolino)</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com">#   [MS-BKRP] Interface implementation</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com">#   Best way to learn how to use these calls is to grab the protocol standard</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com">#   so you understand what the call does, and then read the test case located</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="com">#   at https://github.com/SecureAuthCorp/impacket/tree/master/tests/SMB_RPC</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="com">#   Some calls have helper functions, which makes it even easier to use.</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="pln"><span class="com">#   They are located at the end of this file. </span><span class="strut">&nbsp;</span></p>
<p id="t18" class="pln"><span class="com">#   Helper functions start with "h"&lt;name of the call>.</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="pln"><span class="com">#   There are test cases for them too. </span><span class="strut">&nbsp;</span></p>
<p id="t20" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="pln"><span class="com"># ToDo:</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="pln"><span class="com"># [ ] 2.2.2 Client-Side-Wrapped Secret</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run"><span class="key">from</span> <span class="nam">__future__</span> <span class="key">import</span> <span class="nam">division</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="stm run hide_run"><span class="key">from</span> <span class="nam">__future__</span> <span class="key">import</span> <span class="nam">print_function</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">dcerpc</span><span class="op">.</span><span class="nam">v5</span><span class="op">.</span><span class="nam">ndr</span> <span class="key">import</span> <span class="nam">NDRCALL</span><span class="op">,</span> <span class="nam">NDRPOINTER</span><span class="op">,</span> <span class="nam">NDRUniConformantArray</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">dcerpc</span><span class="op">.</span><span class="nam">v5</span><span class="op">.</span><span class="nam">dtypes</span> <span class="key">import</span> <span class="nam">DWORD</span><span class="op">,</span> <span class="nam">NTSTATUS</span><span class="op">,</span> <span class="nam">GUID</span><span class="op">,</span> <span class="nam">RPC_SID</span><span class="op">,</span> <span class="nam">NULL</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">dcerpc</span><span class="op">.</span><span class="nam">v5</span><span class="op">.</span><span class="nam">rpcrt</span> <span class="key">import</span> <span class="nam">DCERPCException</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">system_errors</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">uuid</span> <span class="key">import</span> <span class="nam">uuidtup_to_bin</span><span class="op">,</span> <span class="nam">string_to_bin</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">structure</span> <span class="key">import</span> <span class="nam">Structure</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm run hide_run"><span class="nam">MSRPC_UUID_BKRP</span> <span class="op">=</span> <span class="nam">uuidtup_to_bin</span><span class="op">(</span><span class="op">(</span><span class="str">'3dde7c30-165d-11d1-ab8f-00805f14db40'</span><span class="op">,</span> <span class="str">'1.0'</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm run hide_run"><span class="key">class</span> <span class="nam">DCERPCSessionError</span><span class="op">(</span><span class="nam">DCERPCException</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">error_string</span><span class="op">=</span><span class="key">None</span><span class="op">,</span> <span class="nam">error_code</span><span class="op">=</span><span class="key">None</span><span class="op">,</span> <span class="nam">packet</span><span class="op">=</span><span class="key">None</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm mis">        <span class="nam">DCERPCException</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">error_string</span><span class="op">,</span> <span class="nam">error_code</span><span class="op">,</span> <span class="nam">packet</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__str__</span><span class="op">(</span> <span class="nam">self</span> <span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm mis">        <span class="nam">key</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">error_code</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm mis">        <span class="key">if</span> <span class="nam">key</span> <span class="key">in</span> <span class="nam">system_errors</span><span class="op">.</span><span class="nam">ERROR_MESSAGES</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm mis">            <span class="nam">error_msg_short</span> <span class="op">=</span> <span class="nam">system_errors</span><span class="op">.</span><span class="nam">ERROR_MESSAGES</span><span class="op">[</span><span class="nam">key</span><span class="op">]</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm mis">            <span class="nam">error_msg_verbose</span> <span class="op">=</span> <span class="nam">system_errors</span><span class="op">.</span><span class="nam">ERROR_MESSAGES</span><span class="op">[</span><span class="nam">key</span><span class="op">]</span><span class="op">[</span><span class="num">1</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm mis">            <span class="key">return</span> <span class="str">'BKRP SessionError: code: 0x%x - %s - %s'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">error_code</span><span class="op">,</span> <span class="nam">error_msg_short</span><span class="op">,</span> <span class="nam">error_msg_verbose</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm mis">            <span class="key">return</span> <span class="str">'BKRP SessionError: unknown error code: 0x%x'</span> <span class="op">%</span> <span class="nam">self</span><span class="op">.</span><span class="nam">error_code</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t47" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="pln"><span class="com"># CONSTANTS</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t51" class="stm run hide_run"><span class="nam">BACKUPKEY_BACKUP_GUID</span> <span class="op">=</span> <span class="nam">string_to_bin</span><span class="op">(</span><span class="str">"7F752B10-178E-11D1-AB8F-00805F14DB40"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="stm run hide_run"><span class="nam">BACKUPKEY_RESTORE_GUID_WIN2K</span> <span class="op">=</span> <span class="nam">string_to_bin</span><span class="op">(</span><span class="str">"7FE94D50-178E-11D1-AB8F-00805F14DB40"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="stm run hide_run"><span class="nam">BACKUPKEY_RETRIEVE_BACKUP_KEY_GUID</span> <span class="op">=</span> <span class="nam">string_to_bin</span><span class="op">(</span><span class="str">"018FF48A-EABA-40C6-8F6D-72370240E967"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="stm run hide_run"><span class="nam">BACKUPKEY_RESTORE_GUID</span> <span class="op">=</span>  <span class="nam">string_to_bin</span><span class="op">(</span><span class="str">"47270C64-2FC7-499B-AC5B-0E37CDCE899A"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t56" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="pln"><span class="com"># STRUCTURES</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="stm run hide_run"><span class="key">class</span> <span class="nam">BYTE_ARRAY</span><span class="op">(</span><span class="nam">NDRUniConformantArray</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="stm run hide_run">    <span class="nam">item</span> <span class="op">=</span> <span class="str">'c'</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t62" class="stm run hide_run"><span class="key">class</span> <span class="nam">PBYTE_ARRAY</span><span class="op">(</span><span class="nam">NDRPOINTER</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="stm run hide_run">    <span class="nam">referent</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="pln">        <span class="op">(</span><span class="str">'Data'</span><span class="op">,</span> <span class="nam">BYTE_ARRAY</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t67" class="pln"><span class="com"># 2.2.4.1 Rc4EncryptedPayload Structure</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="stm run hide_run"><span class="key">class</span> <span class="nam">Rc4EncryptedPayload</span><span class="op">(</span><span class="nam">Structure</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="pln">        <span class="op">(</span><span class="str">'R3'</span><span class="op">,</span> <span class="str">'32s=""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="pln">        <span class="op">(</span><span class="str">'MAC'</span><span class="op">,</span> <span class="str">'20s=""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t72" class="pln">        <span class="op">(</span><span class="str">'SID'</span><span class="op">,</span> <span class="str">':'</span><span class="op">,</span> <span class="nam">RPC_SID</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t73" class="pln">        <span class="op">(</span><span class="str">'Secret'</span><span class="op">,</span> <span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t76" class="pln"><span class="com"># 2.2.4 Secret Wrapped with Symmetric Key</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="stm run hide_run"><span class="key">class</span> <span class="nam">WRAPPED_SECRET</span><span class="op">(</span><span class="nam">Structure</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t79" class="pln">        <span class="op">(</span><span class="str">'SIGNATURE'</span><span class="op">,</span> <span class="str">'&lt;L=1'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="pln">        <span class="op">(</span><span class="str">'Payload_Length'</span><span class="op">,</span> <span class="str">'&lt;L=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="pln">        <span class="op">(</span><span class="str">'Ciphertext_Length'</span><span class="op">,</span> <span class="str">'&lt;L=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t82" class="pln">        <span class="op">(</span><span class="str">'GUID_of_Wrapping_Key'</span><span class="op">,</span> <span class="str">'16s=""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="pln">        <span class="op">(</span><span class="str">'R2'</span><span class="op">,</span> <span class="str">'68s=""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t84" class="pln">        <span class="op">(</span><span class="str">'_Rc4EncryptedPayload'</span><span class="op">,</span> <span class="str">'_-Rc4EncryptedPayload'</span><span class="op">,</span> <span class="str">'self["Payload_Length"]'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t85" class="pln">        <span class="op">(</span><span class="str">'Rc4EncryptedPayload'</span><span class="op">,</span> <span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t86" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t87" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t88" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="pln"><span class="com"># RPC CALLS</span><span class="strut">&nbsp;</span></p>
<p id="t90" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="pln"><span class="com"># 3.1.4.1 BackuprKey(Opnum 0)</span><span class="strut">&nbsp;</span></p>
<p id="t92" class="stm run hide_run"><span class="key">class</span> <span class="nam">BackuprKey</span><span class="op">(</span><span class="nam">NDRCALL</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t93" class="stm run hide_run">    <span class="nam">opnum</span> <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t94" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t95" class="pln">       <span class="op">(</span><span class="str">'pguidActionAgent'</span><span class="op">,</span> <span class="nam">GUID</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t96" class="pln">       <span class="op">(</span><span class="str">'pDataIn'</span><span class="op">,</span> <span class="nam">BYTE_ARRAY</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t97" class="pln">       <span class="op">(</span><span class="str">'cbDataIn'</span><span class="op">,</span> <span class="nam">DWORD</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t98" class="pln">       <span class="op">(</span><span class="str">'dwParam'</span><span class="op">,</span> <span class="nam">DWORD</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t100" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t101" class="stm run hide_run"><span class="key">class</span> <span class="nam">BackuprKeyResponse</span><span class="op">(</span><span class="nam">NDRCALL</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t102" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="pln">       <span class="op">(</span><span class="str">'ppDataOut'</span><span class="op">,</span> <span class="nam">PBYTE_ARRAY</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t104" class="pln">       <span class="op">(</span><span class="str">'pcbDataOut'</span><span class="op">,</span> <span class="nam">DWORD</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t105" class="pln">       <span class="op">(</span><span class="str">'ErrorCode'</span><span class="op">,</span> <span class="nam">NTSTATUS</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t106" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t107" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t108" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="pln"><span class="com"># OPNUMs and their corresponding structures</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t111" class="stm run hide_run"><span class="nam">OPNUMS</span> <span class="op">=</span> <span class="op">{</span><span class="strut">&nbsp;</span></p>
<p id="t112" class="pln"> <span class="num">0</span> <span class="op">:</span> <span class="op">(</span><span class="nam">BackuprKey</span><span class="op">,</span> <span class="nam">BackuprKeyResponse</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t113" class="pln"><span class="op">}</span><span class="strut">&nbsp;</span></p>
<p id="t114" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t115" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t116" class="pln"><span class="com"># HELPER FUNCTIONS</span><span class="strut">&nbsp;</span></p>
<p id="t117" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="stm run hide_run"><span class="key">def</span> <span class="nam">hBackuprKey</span><span class="op">(</span><span class="nam">dce</span><span class="op">,</span> <span class="nam">pguidActionAgent</span><span class="op">,</span> <span class="nam">pDataIn</span><span class="op">,</span> <span class="nam">dwParam</span><span class="op">=</span><span class="num">0</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t119" class="stm run hide_run">    <span class="nam">request</span> <span class="op">=</span> <span class="nam">BackuprKey</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t120" class="stm run hide_run">    <span class="nam">request</span><span class="op">[</span><span class="str">'pguidActionAgent'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">pguidActionAgent</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="stm run hide_run">    <span class="nam">request</span><span class="op">[</span><span class="str">'pDataIn'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">pDataIn</span><span class="strut">&nbsp;</span></p>
<p id="t122" class="stm run hide_run">    <span class="key">if</span> <span class="nam">pDataIn</span> <span class="op">==</span> <span class="nam">NULL</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t123" class="stm run hide_run">        <span class="nam">request</span><span class="op">[</span><span class="str">'cbDataIn'</span><span class="op">]</span> <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t124" class="pln">    <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t125" class="stm run hide_run">        <span class="nam">request</span><span class="op">[</span><span class="str">'cbDataIn'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">pDataIn</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t126" class="stm run hide_run">    <span class="nam">request</span><span class="op">[</span><span class="str">'dwParam'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">dwParam</span><span class="strut">&nbsp;</span></p>
<p id="t127" class="stm run hide_run">    <span class="key">return</span> <span class="nam">dce</span><span class="op">.</span><span class="nam">request</span><span class="op">(</span><span class="nam">request</span><span class="op">)</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
